<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="utf-8">
	<title>CKEditor 5 – markdown editor build – development sample</title>
	<style>
		body {
			max-width: 800px;
			margin: 20px auto;
		}
	</style>
</head>
<body>

<h1>CKEditor 5 – classic editor build – development sample</h1>

<div id="editor">### Library description

Starts a flow after receiving an incoming message, a delivery failure message and/or end-user interaction with the chosen email account.

### Step help:
To use this step you must create a Botmail or connect an external email account to your OneReach.ai account. To do this go to the *Accounts* section, choose the *Specific email accounts* and follow the instructions under the *add an email account*.

Use this step to start a flow after receiving an incoming message, a delivery failure message and/or end-user interaction with the chosen email account. You select the accounts and define the events to follow. When one of the chosen events happens, the flow proceeds down the respective exit.

### Accounts
By default, you can select specific account(s) to follow or add a new account in the dropdown. Option to monitor all added accounts is also available.

### Event types
You can choose up to 7 event types but at least one must be selected. Description of each event is as follows:

- *Reply*: incoming message is received as a reply to the outgoing message.
- *Direct message*: incoming direct message to the chosen email account.
- *Hard bounce*: the outgoing message couldn't be delivered for permanent reasons (e.g. invalid address, the recipient's email server doesn't accept emails etc.)
- *Soft bounce*: the outgoing message couldn't be delivered for temporary reasons (e.g. recipient's inbox is full, the attached file exceeds size limits, etc.)
- *Open*: the outgoing message is opened by the recipient.
- *Click*: the recipient clicks on a link within the outgoing message.
- *Complaint*: the recipient leaves a complaint on the outgoing message.

If a *direct message* or a *reply* events contain attachments, they will be stored in *Files*.

To be able to catch the *open* and *click* event types, the `Request Response (Email)` or `Send Message (Email)` step used to send the outgoing message must have its *enable events handling* option turned ON.

Options to monitor for *complaints*, *hard* and *soft bounces* are available only for Botmail and advaced email accounts, and will be disabled if at least one chosen email account is hosted on existing email servers (e.g. Google, Outlook, IMAP/SMTP).

By default, each chosen event type adds a new exit to the step. To process all events with a singular exit turn on the respective option.

### Event restrictions
`Request Response (Email)` and `Send Message (Email)` step templates have options to handle events. If one of those steps has that option enabled, and the selected event happens, their respective flow will proceed with its execution without triggering the flow with `Wait for Events (Email)` step. To trigger this flow as well, chose the *wait for all events* option.

### Merge field settings
The output data of the step will be stored under the name provided in *merge field name*. It may include the following properties: the time and type of event that triggered the flow, the bot and recipient email addresses, the email contact and content infromation as well as the unique identifiers of the request and response messages. The structure of the output depends on the event that has triggered the step and is as follows:
```json
{
  "event": {
    "email": "",
    "messageId": "",
    "recipient": "",
    "timestamp": 1,
    "type": "",
    "beaconLink": ""
  },
  "message": {
    "messageAt": {
      "date": "",
      "time": "",
      "datetime": ""
    },
    "recipient": {
      "name": "",
      "address": ""
    },
    "to": {
      "name": "",
      "address": ""
    },
    "cc": [],
    "bcc": [],
    "subject": {
      "text": "",
      "trimmed": ""
    },
    "content": {
      "html": "",
      "plaintext": "",
      "trimmedText": ""
    },
    "attachments": [{
      "ext": "",
      "location": "",
      "name": "",
      "size":
    }],
    "messageId": "",
    "inReplyTo": "",
    "references": "",
    "timestamp": 1
  }
}
```

### Advanced settings
The lifespan of a session is set in the *flow session timeout* field and is 20 minutes from the beginning of a session by default. Its limits are between 30 seconds and 48 hours. Examples of acceptable time formats: `32h 3m 12s` or `230m`.


### Reporting
*Step*, *Response Transcript* and *Session* events are reported once the flow exits the step. They collect the data which can be used further in reports. You can specify tags to organize the collected data.


### Release notes
v1.0.0
- initial release
</div>

<script src="../build/ckeditor.js"></script>
<script>
	ClassicEditor.create( document.querySelector( '#editor' ) )
		.then( editor => {
			window.editor = editor;
		} )
		.catch( error => {
			console.error( 'There was a problem initializing the editor.', error );
		} );
</script>

</body>
</html>
